--- /dev/null	2012-08-31 05:09:01.000000000 +0400
+++ new/grubadm/menu.c	2012-08-31 05:09:01.141666449 +0400
@@ -0,0 +1,581 @@
+/*
+ * CDDL HEADER START
+ *
+ * The contents of this file are subject to the terms of the
+ * Common Development and Distribution License (the "License").
+ * You may not use this file except in compliance with the License.
+ *
+ * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+ * or http://www.opensolaris.org/os/licensing.
+ * See the License for the specific language governing permissions
+ * and limitations under the License.
+ *
+ * When distributing Covered Code, include this CDDL HEADER in each
+ * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+ * If applicable, add the following below this CDDL HEADER, with the
+ * fields enclosed by brackets "[]" replaced with your own identifying
+ * information: Portions Copyright [yyyy] [name of copyright owner]
+ *
+ * CDDL HEADER END
+ */
+/*
+ * Copyright 2012, Daniil Lunev. All rights reserved.
+ */
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include "grubadm.h"
+#include "error.h"
+#include "menu.h"
+
+char default_entry[MAX_STRING_SIZE] = { 0 };
+char timeout[MAX_STRING_SIZE] = { 0 };
+char serial[MAX_STRING_SIZE] = { 0 };
+char terminal[MAX_STRING_SIZE] = { 0 };
+
+const char * cmd_list[] = {
+	"entry_name",
+	"pool_label",
+	"pool_uuid",
+	"data_set",
+	"kernel_path",
+	"kernel_options",
+	"module",
+	"default_entry",
+	"timeout",
+	"serial",
+	"terminal",
+	NULL
+};
+
+void
+free_menu (menu_list ** menu)
+{
+	unsigned int i;
+	menu_list * iter = *menu;
+	menu_list * tmp = *menu;
+
+	const char fnc[] = "free_menu";
+
+	debug_print ("%s\n", fnc);
+
+	while (iter) {
+		if (iter->entry.modules_amount)
+			for (i = 0; i < iter->entry.modules_amount; ++i)
+				free (iter->entry.modules[i]);
+		free (iter->entry.modules);
+		tmp = iter;
+		iter = iter->next;
+		free (tmp);
+	}
+
+	*menu = NULL;
+}
+
+static menu_list *
+new_entry (menu_list ** menu, const char * entry_name, const unsigned int num)
+{
+	menu_list * added_entry;
+	menu_list * iter;
+
+	const char fnc[] = "new_entry";
+
+	debug_print ("%s\nargs : %s | %u\n", fnc, entry_name, num);
+
+	added_entry = (menu_list *) calloc (1, sizeof (menu_list));
+	if (! added_entry) {
+		print_system_error ();
+		return NULL;
+	}
+
+	memset ((void *) added_entry, 0, sizeof (menu_list));
+	added_entry->entry_number = num;
+	strcpy (added_entry->entry.entry_name, entry_name);
+	added_entry->entry.modules = 
+		(char **) calloc (MAX_MODULE_AMOUNT, sizeof (char *));
+
+	if (! added_entry->entry.modules) {
+		free_menu (&added_entry);
+		print_system_error ();
+		return NULL;
+	}
+
+	if (! *menu) {
+		*menu = added_entry;
+	} else {
+		for (iter = *menu; iter->next; iter = iter->next) 
+			if (! strcmp (iter->entry.entry_name, entry_name)) {
+				print_error ("%s %s", MSG_ERR_SAME_NAME, entry_name);
+				free_menu (&added_entry);
+				return NULL;
+			}
+		if (! strcmp (iter->entry.entry_name, entry_name)) {
+			print_error ("%s %s", MSG_ERR_SAME_NAME, entry_name);
+			free_menu (&added_entry);
+			return NULL;
+		}	
+		iter->next = added_entry;
+	}
+
+	return added_entry;
+}
+
+menu_list *
+add_entry (menu_list ** menu, menu_list * entry)
+{
+	menu_list * iter;
+
+	const char fnc[] = "add_entry";
+
+	debug_print ("%s\n", fnc);
+
+	if (! entry)
+		return NULL;
+
+	if (! *menu) {
+		entry->entry_number = 0;
+		*menu = entry;
+		return entry;
+	}
+
+	for (iter = * menu; iter->next; iter = iter->next)
+		if (! strcmp (iter->entry.entry_name, entry->entry.entry_name))
+			return NULL;
+		
+	if (! strcmp (iter->entry.entry_name, entry->entry.entry_name))
+		return NULL;
+
+	iter->next = entry;
+	entry->entry_number = iter->entry_number + 1;
+	return entry;
+}
+
+menu_list *
+clone_entry (menu_list * entry)
+{
+	unsigned int i;
+
+	char fnc[] = "clone_entry";
+
+	debug_print ("%s\n", fnc);
+
+	if (! entry)
+		return NULL;
+	menu_list * clone = (menu_list *) calloc (1, sizeof (menu_list));
+	memcpy ((void *) clone, (void *) entry, sizeof (menu_list));
+	clone->next = NULL;
+	clone->entry.modules = (char **) calloc (MAX_MODULE_AMOUNT, sizeof (char *));
+	for (i = 0; i < clone->entry.modules_amount; ++i)
+		clone->entry.modules[i] = strdup (entry->entry.modules[i]);
+	return clone;
+}
+
+menu_list * 
+enable_hyper (menu_list * entry)
+{
+	unsigned int i;
+	char kernel_mod[MAX_STRING_SIZE];
+
+	char fnc[] = "enable_hyper";
+
+	debug_print ("%s\n", fnc);
+
+	if (! entry)
+		return NULL;
+	
+	strcpy (kernel_mod, entry->entry.kernel);
+	strcat (kernel_mod, " ");
+	strcat (kernel_mod, entry->entry.kernel);
+	strcat (kernel_mod, " ");
+	strcat (kernel_mod, entry->entry.kernel_opts);
+
+	strcpy (entry->entry.kernel, HYPER_KERNEL);
+	strcpy (entry->entry.kernel_opts, HYPER_KERNEL_OPTS);
+	
+	for (i = entry->entry.modules_amount; i > 0; --i) 
+		entry->entry.modules[i] = entry->entry.modules[i-1];
+	entry->entry.modules[0] = strdup (kernel_mod);
+	++(entry->entry.modules_amount);
+
+	return entry;
+}
+
+menu_list *
+disable_hyper (menu_list * entry)
+{
+	unsigned int i;
+	char * tmp;
+
+	char fnc[] = "disable_hyper";
+
+	debug_print ("%s\n", fnc);
+
+	if (! entry)
+		return NULL;
+
+	tmp = strchr (entry->entry.modules[0], ' ');
+	if (! tmp)
+		return NULL;
+
+	*tmp++ = '\0';
+
+	strcpy (entry->entry.kernel, entry->entry.modules[0]);
+	
+	entry->entry.kernel_opts[0] = '\0';
+	tmp = strchr(tmp, ' ');
+	if (tmp && *(++tmp)) {
+		strcpy (entry->entry.kernel_opts, tmp);
+	}
+	free (entry->entry.modules[0]);
+	--(entry->entry.modules_amount);
+
+	for (i = 0; i < entry->entry.modules_amount; ++i)
+		entry->entry.modules[i] = entry->entry.modules[i + 1];
+
+	return entry;
+}
+
+int
+delete_entry (menu_list ** menu, menu_list * del)
+{
+	menu_list * iter = *menu;
+	int d_num, i_num;
+
+	const char fnc[] = "delete_entry";
+
+	debug_print ("%s\n", fnc);
+
+	if (! menu || ! del)
+		return 0;
+
+	i_num = del->entry_number;
+
+	if (iter == del) {
+		*menu = (*menu)->next;
+		iter->next = NULL;
+		free_menu (&iter);
+	} else {
+		while (iter->next) {
+			if (iter->next == del) {
+				iter->next = del->next;
+				del->next = NULL;
+				free_menu (&del);
+				break;
+			}
+			iter = iter->next;
+		}
+	}
+
+	sscanf (default_entry, "%d", &d_num);
+
+	if (i_num <= d_num) {
+		d_num = d_num ? d_num - 1 : 0;
+		sprintf (default_entry, "%d", d_num);
+	}
+
+	return 0;
+}
+
+static menu_list *
+add_param (menu_list ** menu, 
+		const cmd_id id,
+		const char * value, 
+		unsigned int * num)
+{
+	menu_list * iter;
+	char * tmp;
+
+	const char fnc[] = "add_param";
+
+	debug_print ("%s\narg: %u | %s | %u\n", fnc, (unsigned int) id, value, *num);
+
+	if (id == CMD_ENTRY_NAME)
+		return new_entry (menu, value, (*num)++);
+
+	if (! *menu) {
+		print_error ("%s, %s", MSG_ERR_WRONG_SYNTAX, "entry isn't defined");
+	}
+
+	for (iter = * menu; iter->next; iter = iter->next)
+		;
+
+	switch (id) {
+	case CMD_POOL_LABEL:
+		strcpy (iter->entry.pool_label, value);
+		break;
+	case CMD_POOL_UUID:
+		strcpy (iter->entry.pool_uuid, value);
+		break;
+	case CMD_DATA_SET:
+		strcpy (iter->entry.dataset, value);
+		break;
+	case CMD_KERNEL_PATH:
+		strcpy (iter->entry.kernel, value);
+		break;
+	case CMD_KERNEL_OPTIONS:
+		strcpy (iter->entry.kernel_opts, value);
+		break;
+	case CMD_BA_PATH:
+		if (iter->entry.modules_amount >= MAX_MODULE_AMOUNT)
+			return NULL; 
+		iter->entry.modules[iter->entry.modules_amount] = 
+			(char *) malloc (MAX_STRING_SIZE);
+		if (! iter->entry.modules[iter->entry.modules_amount])
+			return NULL;
+		strcpy (iter->entry.modules[iter->entry.modules_amount], value);
+		++(iter->entry.modules_amount);
+		break;
+	default:
+		return NULL;
+	}
+	return iter;
+}
+
+void
+list_menu (menu_list * menu)
+{
+	const char fnc[] = "list_menu";
+
+	debug_print ("%s\n", fnc);
+
+	if (*default_entry)
+		printf ("%s%s%s\n", cmd_list[CMD_DEFAULT], SEPARATOR, default_entry);
+
+	if (*timeout) 
+		printf ("%s%s%s\n", cmd_list[CMD_TIMEOUT], SEPARATOR, timeout);
+
+	if (*serial)
+		printf ("%s%s%s\n", cmd_list[CMD_SERIAL], SEPARATOR, serial);
+
+	if (*terminal)
+		printf ("%s%s%s\n", cmd_list[CMD_TERMINAL], SEPARATOR, terminal);
+
+	while (menu) {
+		printf("%u : %s\n", menu->entry_number, menu->entry.entry_name);
+		menu = menu->next;
+	}
+}
+
+menu_list *
+find_entry (menu_list * menu, menu_list * find)
+{
+	unsigned int i = 0;
+	const char fnc[] = "find_entry";
+
+	debug_print ("%s\n", fnc);
+
+	if (! menu || ! find)
+		return NULL;
+
+	while (menu) {
+		if (find->entry.entry_name[0])
+			if (strcmp (menu->entry.entry_name, find->entry.entry_name))
+				goto out;
+		if (find->entry.pool_label[0])
+			if (strcmp (menu->entry.pool_label, find->entry.pool_label))
+				goto out;
+		if (find->entry.pool_uuid[0])
+			if (strcmp (menu->entry.pool_uuid, find->entry.pool_uuid))
+				goto out;
+		if (find->entry.dataset[0])
+			if (strcmp (menu->entry.dataset, find->entry.dataset))
+				goto out;
+		if (find->entry.kernel[0])
+			if (strcmp (menu->entry.kernel, find->entry.kernel))
+				goto out;
+
+		if (find->entry.modules_amount) {
+			for (i = 0; i < menu->entry.modules_amount; ++i)
+				if (! strcmp (menu->entry.modules[i], find->entry.modules[0]))
+					return menu;
+			goto out;
+		}
+
+		return menu;
+out:
+		menu = menu->next;
+	}
+
+	return NULL;
+}
+
+menu_list *
+get_entry_by_number (menu_list * menu, int number)
+{
+	while (menu) 
+		if (menu->entry_number == number)
+			return menu;
+		else
+			menu = menu->next;
+	return NULL;
+}
+
+static size_t
+get_line (FILE * menu_file, char * line)
+{
+	const char fnc[] = "get_line";
+	
+	debug_print ("%s\n", fnc);
+
+	if (! fgets (line, MAX_STRING_SIZE, menu_file)) {
+		if (! feof (menu_file))
+			print_system_error ();
+		return -1;
+	}
+
+	if ((line[strlen (line) - 1] != '\n') && (! feof (menu_file))) {
+		print_error ("%s (> %d)", MSG_ERR_LONG_LINE, MAX_STRING_SIZE);
+		return -1;
+	}
+
+	line[strlen (line) - 1] = '\0';
+
+	return strlen (line);
+}
+
+static cmd_id
+get_param_id (const char * param)
+{
+	unsigned int id;
+
+	const char fnc[] = "get_param_id";
+
+	debug_print ("%s\narg : %s\n", fnc, param);
+
+	for (id = 0; cmd_list[id]; ++id)
+		if (! strcmp (cmd_list[id], param))
+			break;
+
+	return id;		
+}
+
+menu_list *
+parse_file (const char * file_name, int * entries_amount)
+{
+	FILE * menu_file = NULL;
+	unsigned int counter = 0;
+	menu_list * menu = NULL;
+	char line[MAX_STRING_SIZE];
+	char * param;
+	char * value;
+	cmd_id id;
+	
+	const char fnc[] = "parse_file";
+
+	debug_print ("%s\narg : %s\n", fnc, file_name);
+
+	menu_file = fopen (file_name, "r");
+	if (! menu_file) {
+		print_system_error ();
+		goto out;
+	}
+
+	for (;;) {
+		if (get_line (menu_file, line) == -1) {
+			if (feof (menu_file))
+				break;
+			free_menu (&menu);
+			counter = -1;
+			goto out;
+		}
+
+		if (line[0] == '#')
+			continue;
+		
+		param = line;
+		while ((*param == ' ') || (*param == '\t'))
+			++ param;
+		if (*param == '\0')
+			continue;
+
+		value = strchr (line, '=');
+		if (! value) {
+			print_error ("%s at line '%s'", MSG_ERR_WRONG_SYNTAX, line);
+			free_menu (&menu);
+			counter = -1;
+			goto out;
+		} 
+		*value++ = '\0';
+
+		id = get_param_id (param);
+		if (id == CMD_UNKNOWN) {
+			print_error ("%s at line '%s'", MSG_ERR_WRONG_SYNTAX, line);
+			free_menu (&menu);
+			counter = -1;
+			goto out;
+		}
+
+		if (id == CMD_DEFAULT) {
+			strcpy (default_entry, value);
+		} else if (id == CMD_TIMEOUT) {
+			strcpy (timeout, value);
+		} else if (id == CMD_SERIAL) {
+			strcpy (serial, value);
+		} else if (id == CMD_TERMINAL) {
+			strcpy (terminal, value);
+		} else if (! add_param (&menu, id, value, &counter)) {
+			free_menu (&menu);
+			counter = -1;
+			goto out;
+		}
+	}
+
+out:
+	if (menu_file)
+		fclose (menu_file);
+
+	*entries_amount = counter;
+
+	return menu;
+}
+
+int
+write_menu (const char * config, const char * tmp_config, menu_list * menu)
+{
+	FILE * tmp_menu = fopen (tmp_config, "w");
+	unsigned int i = 0;
+
+	const char fnc[] = "write_menu";
+
+	debug_print ("%s\n", fnc);
+
+	if (! tmp_menu) {
+		print_system_error();
+		return 0;
+	}
+	
+	if (default_entry[0])
+		fprintf (tmp_menu, "%s%s%s\n", cmd_list[CMD_DEFAULT], SEPARATOR, default_entry);
+	if (timeout[0])
+		fprintf (tmp_menu, "%s%s%s\n\n", cmd_list[CMD_TIMEOUT], SEPARATOR, timeout);
+	if (serial[0])
+		fprintf (tmp_menu, "%s%s%s\n\n", cmd_list[CMD_SERIAL], SEPARATOR, serial);
+	if (terminal[0])
+		fprintf (tmp_menu, "%s%s%s\n\n", cmd_list[CMD_TERMINAL], SEPARATOR, terminal);
+
+	while (menu) {
+		fprintf (tmp_menu, "%s%s%s\n", cmd_list[CMD_ENTRY_NAME], SEPARATOR, menu->entry.entry_name);
+		if (menu->entry.pool_label[0])
+			fprintf (tmp_menu, "%s%s%s\n", cmd_list[CMD_POOL_LABEL], SEPARATOR, menu->entry.pool_label);
+		if (menu->entry.pool_uuid[0])
+			fprintf (tmp_menu, "%s%s%s\n", cmd_list[CMD_POOL_UUID], SEPARATOR, menu->entry.pool_uuid);
+		if (menu->entry.dataset[0])
+			fprintf (tmp_menu, "%s%s%s\n", cmd_list[CMD_DATA_SET], SEPARATOR, menu->entry.dataset);
+		if (menu->entry.kernel[0])
+			fprintf (tmp_menu, "%s%s%s\n", cmd_list[CMD_KERNEL_PATH], SEPARATOR, menu->entry.kernel);
+		if (menu->entry.kernel_opts[0])
+			fprintf (tmp_menu, "%s%s%s\n", cmd_list[CMD_KERNEL_OPTIONS], SEPARATOR, menu->entry.kernel_opts);
+		if (menu->entry.modules_amount)
+			for (i = 0; i < menu->entry.modules_amount; ++i)
+				fprintf (tmp_menu, "%s%s%s\n", cmd_list[CMD_BA_PATH], SEPARATOR, menu->entry.modules[i]);
+		fprintf (tmp_menu, "#----------------------------------------------------\n");
+		menu = menu->next;
+	}
+
+	fclose (tmp_menu);
+
+	remove (config);
+	rename (tmp_config, config);
+
+	return 1;
+}
--- /dev/null	2012-08-31 05:09:01.000000000 +0400
+++ new/grubadm/menu.h	2012-08-31 05:09:01.443277154 +0400
@@ -0,0 +1,98 @@
+/*
+ * CDDL HEADER START
+ *
+ * The contents of this file are subject to the terms of the
+ * Common Development and Distribution License (the "License").
+ * You may not use this file except in compliance with the License.
+ *
+ * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+ * or http://www.opensolaris.org/os/licensing.
+ * See the License for the specific language governing permissions
+ * and limitations under the License.
+ *
+ * When distributing Covered Code, include this CDDL HEADER in each
+ * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+ * If applicable, add the following below this CDDL HEADER, with the
+ * fields enclosed by brackets "[]" replaced with your own identifying
+ * information: Portions Copyright [yyyy] [name of copyright owner]
+ *
+ * CDDL HEADER END
+ */
+/*
+ * Copyright 2012, Daniil Lunev. All rights reserved.
+ */
+
+#define SEPARATOR "="
+
+typedef struct menu_entry menu_entry;
+typedef struct menu_list menu_list;
+typedef enum cmd_id cmd_id;
+
+struct menu_entry {
+	char entry_name[MAX_STRING_SIZE];
+	char pool_label[MAX_STRING_SIZE];
+	char pool_uuid[MAX_STRING_SIZE];
+	char dataset[MAX_STRING_SIZE];
+	char kernel[MAX_STRING_SIZE];
+	char kernel_opts[MAX_STRING_SIZE];
+	unsigned int modules_amount;
+	char ** modules;
+};
+
+extern char default_entry[MAX_STRING_SIZE];
+extern char timeout[MAX_STRING_SIZE];
+extern char serial[MAX_STRING_SIZE];
+extern char terminal[MAX_STRING_SIZE];
+
+struct menu_list {
+	unsigned int entry_number;
+	menu_entry entry;
+	menu_list * next;
+};
+
+enum cmd_id {
+	CMD_ENTRY_NAME,
+	CMD_POOL_LABEL,
+	CMD_POOL_UUID,
+	CMD_DATA_SET,
+	CMD_KERNEL_PATH,
+	CMD_KERNEL_OPTIONS,
+	CMD_BA_PATH,
+	CMD_DEFAULT,
+	CMD_TIMEOUT,
+	CMD_SERIAL,
+	CMD_TERMINAL,
+	CMD_UNKNOWN
+};
+
+extern const char * cmd_list[];
+
+void
+free_menu (menu_list ** menu);
+
+menu_list *
+parse_file (const char * file_name, int * entries_amount);
+
+void
+list_menu (menu_list * menu);
+
+menu_list *
+add_entry (menu_list ** menu, menu_list * entry);
+
+menu_list *
+clone_entry (menu_list  *entry);
+
+int
+delete_entry (menu_list ** menu, menu_list * del);
+
+menu_list *
+find_entry (menu_list * menu, menu_list * find);
+
+menu_list *
+enable_hyper (menu_list * entry);
+
+menu_list *
+disable_hyper (menu_list * entry);
+
+menu_list *
+get_entry_by_number (menu_list * menu, int number);
--- old/libbe/common/be_utils.c	2012-08-31 05:09:01.777503166 +0400
+++ new/libbe/common/be_utils.c	2012-08-31 05:09:01.806511114 +0400
@@ -461,11 +461,11 @@
 		char *tok = NULL;
 
 		(void) strlcpy(temp_line, line, BUFSIZ);
-		tok = strtok(line, BE_WHITE_SPACE);
+		tok = strtok(line, "=\n");
 
 		if (tok == NULL || tok[0] == '#') {
 			continue;
-		} else if (strcmp(tok, "title") == 0) {
+		} else if (strcmp(tok, "entry_name") == 0) {
 			collect_lines = B_FALSE;
 			if ((tok = strtok(NULL, "\n")) == NULL)
 				(void) strlcpy(title, "", sizeof (title));
@@ -480,7 +480,7 @@
 				}
 				num_tmp_lines = 0;
 			}
-		} else if (strcmp(tok, "bootfs") == 0) {
+		} else if (strcmp(tok, "data_set") == 0) {
 			char *bootfs = strtok(NULL, BE_WHITE_SPACE);
 			found_title = B_FALSE;
 			if (bootfs == NULL)
@@ -500,7 +500,7 @@
 				/*
 				 * Store the new title line
 				 */
-				(void) snprintf(str, BUFSIZ, "title %s\n",
+				(void) snprintf(str, BUFSIZ, "entry_name=%s\n",
 				    description ? description : be_name);
 				entries[num_lines] = strdup(str);
 				num_lines++;
@@ -514,11 +514,31 @@
 					tmp_entries[i] = NULL;
 					num_lines++;
 				}
-				num_tmp_lines = 0;
+
+				zprop_get_cbdata_t cb = { 0 };
+				zprop_source_t src;
+				char * bc = strchr(be_root_ds, '/');
+				char sguid[] = "guid";
+
+				*bc = '\0';
+				cb.cb_first = B_TRUE;
+				cb.cb_sources = ZPROP_SRC_ALL;
+				cb.cb_type = ZFS_TYPE_POOL;
+				zprop_get_list(g_zfs, sguid, &cb.cb_proplist, ZFS_TYPE_POOL);
+				zpool_handle_t * z_hndl = zpool_open(g_zfs, be_root_ds);
+				*bc = '/';
+				if (z_hndl) {
+					uint64_t guid = zpool_get_prop_int(z_hndl, cb.cb_proplist->pl_prop, &src);
+					(void) snprintf(str, BUFSIZ, "pool_uuid=%llx\n", guid);
+					entries[num_lines] = strdup(str);
+					num_lines++;
+					zpool_close(z_hndl);
+				}
+num_tmp_lines = 0;
 				/*
 				 * Store the new bootfs line.
 				 */
-				(void) snprintf(str, BUFSIZ, "bootfs %s\n",
+				(void) snprintf(str, BUFSIZ, "data_set=%s\n",
 				    be_root_ds);
 				entries[num_lines] = strdup(str);
 				num_lines++;
@@ -536,6 +556,19 @@
 				entries[num_lines] =
 				    strdup("splashimage "
 				    "/boot/splashimage.xpm\n");
+			} else if ((strcmp(tok, "kernel_path") == 0) || 
+				(strcmp(tok, "module") == 0)) 
+			{
+				char * path;
+				char * st_path;
+				
+				st_path = strtok(NULL, "\n");
+				path = (char *) malloc(512);
+				strcpy(path, tok);
+				strcat(path, "=");
+				strcat(path, st_path);
+				strcat(path, "\n");
+				entries[num_lines] = path;
 			} else {
 				entries[num_lines] = strdup(temp_line);
 			}
@@ -598,18 +631,36 @@
 			(void) fprintf(menu_fp, "%s\n", BE_GRUB_COMMENT);
 		ret = BE_SUCCESS;
 	} else {
-		(void) fprintf(menu_fp, "title %s\n",
+		zprop_get_cbdata_t cb = { 0 };
+		zprop_source_t src;
+		char * bc = strchr(be_root_ds, '/');
+		char sguid[] = "guid";
+
+		(void) fprintf(menu_fp, "entry_name=%s\n",
 		    description ? description : be_name);
-		(void) fprintf(menu_fp, "bootfs %s\n", be_root_ds);
+		*bc = '\0';
+		cb.cb_first = B_TRUE;
+		cb.cb_sources = ZPROP_SRC_ALL;
+		cb.cb_type = ZFS_TYPE_POOL;
+		zprop_get_list(g_zfs, sguid, &cb.cb_proplist, ZFS_TYPE_POOL);
+		zpool_handle_t * z_hndl = zpool_open(g_zfs, be_root_ds);
+		*bc = '/';
+		if (z_hndl) {
+			uint64_t guid = zpool_get_prop_int(z_hndl, cb.cb_proplist->pl_prop, &src);
+			(void) fprintf(menu_fp, "pool_uuid=%llx\n", guid);
+			zpool_close(z_hndl);
+		}
+		(void) fprintf(menu_fp, "data_set=%s\n", be_root_ds);
 
 		/*
 		 * Check to see if this system supports grub
 		 */
 		if (be_has_grub()) {
-			(void) fprintf(menu_fp, "kernel$ "
-			    "/platform/i86pc/kernel/$ISADIR/unix -B "
-			    "$ZFS-BOOTFS\n");
-			(void) fprintf(menu_fp, "module$ "
+			(void) fprintf(menu_fp, "kernel_path="
+			    "/platform/i86pc/kernel/$ISADIR/unix\n");
+			(void) fprintf(menu_fp, "kernel_options="
+			    "-B $ZFS_BOOTFS,console=graphic\n");
+			(void) fprintf(menu_fp, "module="
 			    "/platform/i86pc/$ISADIR/boot_archive\n");
 			(void) fprintf(menu_fp, "%s\n", BE_GRUB_COMMENT);
 		}
@@ -789,7 +840,7 @@
 		(void) strlcpy(tline, menu_buf, sizeof (tline));
 
 		/* Tokenize line */
-		tok = strtok(tline, BE_WHITE_SPACE);
+		tok = strtok(tline, "=\n");
 
 		if (tok == NULL || tok[0] == '#') {
 			/* Found empty line or comment line */
@@ -811,7 +862,7 @@
 				/* Write this line out */
 				(void) fputs(menu_buf, tmp_menu_fp);
 			}
-		} else if (strcmp(tok, "default") == 0) {
+		} else if (strcmp(tok, "default_entry") == 0) {
 			/*
 			 * Record what 'default' is set to because we might
 			 * need to adjust this upon deleting an entry.
@@ -823,7 +874,7 @@
 			}
 
 			(void) fputs(menu_buf, tmp_menu_fp);
-		} else if (strcmp(tok, "title") == 0) {
+		} else if (strcmp(tok, "entry_name") == 0) {
 			/*
 			 * If we've reached a 'title' line and do_buffer is
 			 * is true, that means we've just buffered an entire
@@ -859,7 +910,7 @@
 				goto cleanup;
 			}
 
-		} else if (strcmp(tok, "bootfs") == 0) {
+		} else if (strcmp(tok, "data_set") == 0) {
 			char *bootfs = NULL;
 
 			/*
@@ -1020,15 +1071,15 @@
 				(void) strlcpy(tline, menu_buf, sizeof (tline));
 
 				/* Tokenize line */
-				tok = strtok(tline, BE_WHITE_SPACE);
+				tok = strtok(tline, "=\n");
 
 				if (tok == NULL) {
 					/* Found empty line, write it out */
 					(void) fputs(menu_buf, tmp_menu_fp);
-				} else if (strcmp(tok, "default") == 0) {
+				} else if (strcmp(tok, "default_entry") == 0) {
 					/* Found the default line, adjust it */
 					(void) snprintf(tline, sizeof (tline),
-					    "default %d\n", default_entry);
+					    "default_entry=%d\n", default_entry);
 
 					(void) fputs(tline, tmp_menu_fp);
 				} else {
@@ -1187,11 +1238,11 @@
 	pool_mntpnt = NULL;
 
 	while (fgets(line, BUFSIZ, menu_fp)) {
-		char *tok = strtok(line, BE_WHITE_SPACE);
+		char *tok = strtok(line, "=\n");
 
 		if (tok != NULL && tok[0] != '#') {
 			if (!found_default) {
-				if (strcmp(tok, "default") == 0) {
+				if (strcmp(tok, "default_entry") == 0) {
 					tok = strtok(NULL, BE_WHITE_SPACE);
 					if (tok != NULL) {
 						default_entry = atoi(tok);
@@ -1201,10 +1252,10 @@
 				}
 				continue;
 			}
-			if (strcmp(tok, "title") == 0) {
+			if (strcmp(tok, "entry_name") == 0) {
 				entries++;
 			} else if (default_entry == entries - 1) {
-				if (strcmp(tok, "bootfs") == 0) {
+				if (strcmp(tok, "data_set") == 0) {
 					tok = strtok(NULL, BE_WHITE_SPACE);
 					(void) fclose(menu_fp);
 
@@ -1387,14 +1438,14 @@
 	}
 
 	while (fgets(line, BUFSIZ, grub_fp)) {
-		char *tok = strtok(line, BE_WHITE_SPACE);
+		char *tok = strtok(line, "=\n");
 
 		if (tok == NULL || tok[0] == '#') {
 			continue;
-		} else if (strcmp(tok, "title") == 0) {
+		} else if (strcmp(tok, "entry_name") == 0) {
 			entries++;
 			continue;
-		} else if (strcmp(tok, "bootfs") == 0) {
+		} else if (strcmp(tok, "data_set") == 0) {
 			char *bootfs = strtok(NULL, BE_WHITE_SPACE);
 			if (bootfs == NULL)
 				continue;
@@ -1416,16 +1467,16 @@
 
 	rewind(grub_fp);
 
+	(void) snprintf(temp_line, BUFSIZ, "default_entry=%d\n",
+	    entries - 1 >= 0 ? entries - 1 : 0);
+	(void) fputs(temp_line, temp_fp);
 	while (fgets(line, BUFSIZ, grub_fp)) {
 		char *tok = NULL;
 
 		(void) strncpy(temp_line, line, BUFSIZ);
 
-		if ((tok = strtok(temp_line, BE_WHITE_SPACE)) != NULL &&
-		    strcmp(tok, "default") == 0) {
-			(void) snprintf(temp_line, BUFSIZ, "default %d\n",
-			    entries - 1 >= 0 ? entries - 1 : 0);
-			(void) fputs(temp_line, temp_fp);
+		if ((tok = strtok(temp_line, "=\n")) != NULL &&
+		    strcmp(tok, "default_entry") == 0) {
 		} else {
 			(void) fputs(line, temp_fp);
 		}
@@ -1520,6 +1571,7 @@
 	int temp_menu_len = 0;
 	int tmp_fd;
 	int ret = BE_SUCCESS;
+	int flag = 0;
 	int err = 0;
 	boolean_t pool_mounted = B_FALSE;
 
@@ -1636,7 +1688,7 @@
 		(void) strlcpy(tline, line, sizeof (tline));
 
 		/* Tokenize line */
-		c = strtok(tline, BE_WHITE_SPACE);
+		c = strtok(tline, "=\n");
 
 		if (c == NULL) {
 			/* Found empty line, write it out. */
@@ -1644,7 +1696,7 @@
 		} else if (c[0] == '#') {
 			/* Found a comment line, write it out. */
 			(void) fputs(line, new_fp);
-		} else if (strcmp(c, "title") == 0) {
+		} else if (strcmp(c, "entry_name") == 0) {
 			char *name = NULL;
 			char *desc = NULL;
 
@@ -1652,6 +1704,7 @@
 			 * Found a 'title' line, parse out BE name or
 			 * the description.
 			 */
+			flag = 0;
 			name = strtok(NULL, BE_WHITE_SPACE);
 
 			if (name == NULL) {
@@ -1675,15 +1728,16 @@
 					 * along with the remainder of
 					 * description if there is one.
 					 */
+					++flag;
 					if (desc) {
 						(void) snprintf(new_line,
 						    sizeof (new_line),
-						    "title %s %s\n",
+						    "entry_name=%s %s\n",
 						    be_new_name, desc);
 					} else {
 						(void) snprintf(new_line,
 						    sizeof (new_line),
-						    "title %s\n", be_new_name);
+						    "entry_name=%s\n", be_new_name);
 					}
 
 					(void) fputs(new_line, new_fp);
@@ -1691,7 +1745,7 @@
 					(void) fputs(line, new_fp);
 				}
 			}
-		} else if (strcmp(c, "bootfs") == 0) {
+		} else if (strcmp(c, "data_set") == 0) {
 			/*
 			 * Found a 'bootfs' line, parse out the BE root
 			 * dataset value.
@@ -1710,8 +1764,9 @@
 				 * write out the new root dataset value
 				 */
 				if (strcmp(root_ds, be_root_ds) == 0) {
+					++flag;
 					(void) snprintf(new_line,
-					    sizeof (new_line), "bootfs %s\n",
+					    sizeof (new_line), "data_set=%s\n",
 					    be_new_root_ds);
 
 					(void) fputs(new_line, new_fp);
@@ -1853,10 +1908,10 @@
 	rpool_mntpnt = NULL;
 
 	while (fgets(line, BUFSIZ, menu_fp)) {
-		char *tok = strtok_r(line, BE_WHITE_SPACE, &last);
+		char *tok = strtok_r(line, "=\n", &last);
 
 		if (tok != NULL && tok[0] != '#') {
-			if (strcmp(tok, "bootfs") == 0) {
+			if (strcmp(tok, "data_set") == 0) {
 				tok = strtok_r(last, BE_WHITE_SPACE, &last);
 				if (tok != NULL && strcmp(tok,
 				    be_dataset) == 0) {
@@ -1873,7 +1928,7 @@
 					ret = B_TRUE;
 					goto cleanup;
 				}
-			} else if (strcmp(tok, "title") == 0)
+			} else if (strcmp(tok, "entry_name") == 0)
 				ent_num++;
 		}
 	}
@@ -3639,14 +3694,14 @@
 			if (strncmp(console, "text", strlen("text")) == 0 ||
 			    strncmp(console, "graphics",
 			    strlen("graphics")) == 0) {
-
+/*
 				(void) fprintf(temp_fp, "%s\n", BE_GRUB_SPLASH);
 				(void) fprintf(temp_fp, "%s\n",
 				    BE_GRUB_FOREGROUND);
 				(void) fprintf(temp_fp, "%s\n",
 				    BE_GRUB_BACKGROUND);
 				(void) fprintf(temp_fp, "%s\n",
-				    BE_GRUB_DEFAULT);
+				    BE_GRUB_DEFAULT);*/
 			} else {
 				be_print_err(gettext("be_create_menu: "
 				    "console on serial line, "
@@ -3654,7 +3709,7 @@
 			}
 		}
 
-		(void) fprintf(temp_fp,	"timeout 30\n");
+		(void) fprintf(temp_fp,	"timeout=30\n");
 		(void) fclose(temp_fp);
 
 	} else {
